#include "StdAfx.h"

//*************************************************
//#include "C:MELSEC\Act\Include\ActUtlType_i.h"
//#include "C:MELSEC\Act\Include\ActUtlType_i.c"
#include "ActUtltype_i.h"
#include "ActUtltype_i.c"
//*************************************************

#include "MXComp.h"
#include "atlstr.h"

MXComp::MXComp(void)
{
	OpenFlg=FALSE;
	mp_IActUtlType=NULL;

	HRESULT hres=::CoInitialize(NULL);
}


MXComp::~MXComp(void)
{
	if(OpenFlg==TRUE)
		Close();

	if(mp_IActUtlType != NULL)
		mp_IActUtlType->Release();

	::CoUninitialize();
}

bool MXComp::Create(void)
{
	//R|[lg̃CX^X쐬
	//sꍇmp_IActUtlTypeNULL
	HRESULT hr=CoCreateInstance(CLSID_ActUtlType,NULL,CLSCTX_INPROC_SERVER,
								IID_IActUtlType,(LPVOID*)&mp_IActUtlType);
	if(!SUCCEEDED(hr))
	{
		::CoUninitialize();
		return FALSE;
	}

	return TRUE;
}

bool MXComp::Open(int StationNo)
{
	long iRet;
	HRESULT hr=mp_IActUtlType->put_ActLogicalStationNumber(StationNo);
	if(SUCCEEDED(hr))
	{
		hr=mp_IActUtlType->Open(&iRet);
		if(hr==S_FALSE)
			return FALSE;
	}
	else
		return FALSE;

	OpenFlg=TRUE;
	return TRUE;
}

bool MXComp::Close(void)
{
	long lRet;

	if(OpenFlg==TRUE)
	{
		HRESULT hr=mp_IActUtlType->Close(&lRet);
		if(!SUCCEEDED(hr))
			return FALSE;
	}
	OpenFlg=FALSE;
	return TRUE;
}

bool MXComp::GetDevice(LPSTR strDev,long* val)
{
	long lRet;
	CString m_Device=strDev;
	if(m_Device=="" || OpenFlg==FALSE)
		return FALSE;

	BSTR bsDevice=m_Device.AllocSysString();

	//Ǐo
	HRESULT hr=mp_IActUtlType->GetDevice(bsDevice,val,&lRet);
	if(!SUCCEEDED(hr))
		return FALSE;

	
	::SysFreeString(bsDevice);
	return TRUE;
}

bool MXComp::GetDeviceBlock(LPSTR strDev,int DevCount,long* val)
{
	long iRet;
	CString m_Device=strDev;
	if(m_Device=="" || OpenFlg==FALSE)
		return FALSE;

	BSTR bsDevice=m_Device.AllocSysString();

	HRESULT hr=mp_IActUtlType->ReadDeviceBlock(bsDevice,DevCount,val,&iRet);

	return TRUE;
}

bool MXComp::SetDeviceBlock(LPSTR strDev,int DevCount,long* val)
{
	long iRet;
	CString m_Device=strDev;
	if(m_Device=="" || OpenFlg==FALSE)
		return FALSE;

	BSTR bsDevice=m_Device.AllocSysString();

	HRESULT hr=mp_IActUtlType->WriteDeviceBlock(bsDevice,(LONG)DevCount,val,&iRet);

	return TRUE;
}

bool MXComp::SetDevice(LPSTR strDev,long val)
{
	long lRet;
	CString m_Device=strDev;

	if((m_Device=="") || (OpenFlg==FALSE))
		return FALSE;

	BSTR bsDevice=m_Device.AllocSysString();

	HRESULT hr=mp_IActUtlType->SetDevice(bsDevice,val,&lRet);
	if(!SUCCEEDED(hr))
		return FALSE;

	::SysFreeString(bsDevice);
	return TRUE;
}
