// PLC_Simulation(SDK).cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "PLC_Simulation(SDK).h"
#include "TabDlg0.h"
#include "TabDlg1.h"
#include "TabDlg2.h"
#include "cThread.h"
#include "atlstr.h"
#include "Shellapi.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
HWND hTabDlg0,hTabDlg1,hTabDlg2;				//^uɕ\_CAÕnh
TabDlg0* ppTabDlg0;								
TabDlg1* ppTabDlg1;								
TabDlg2* ppTabDlg2;

cThread* mxThread;								//MXR|[lgpXbh

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
BOOL    CALLBACK	dlgProc(HWND,UINT,WPARAM,LPARAM);
INT_PTR CALLBACK	About(HWND,UINT,WPARAM,LPARAM);
BOOL				SetTabDlg0(HINSTANCE,HWND);
BOOL				SetTabDlg1(HINSTANCE,HWND);
BOOL				SetTabDlg2(HINSTANCE,HWND);
VOID				TabDlgClose();
VOID				SetTabPage(HWND);
VOID				SetMonitorData();
VOID				SetForceOut();

//AvP[ṼGg[|Cg
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	hInst=hInstance;
	HWND hdlg;
	hdlg=(HWND)DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),
				HWND_DESKTOP,(DLGPROC)dlgProc);
	
	return 0;
}

// o[W{bNX̃bZ[W nh[łB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

//C_CAÕbZ[Wnh
BOOL CALLBACK dlgProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	static int nNo;
	static HWND hTab;
	static HWND hBtOpen;
	static HWND hBtClose;
	static HWND hBtStart;
	static HWND hBtStop;
	HINSTANCE hinst;
	
	switch(msg)
	{
	case WM_INITDIALOG:					//_CAOݒ
		hTab=GetDlgItem(hwnd,IDC_TAB1);
		SetTabPage(hwnd);
		SetTabDlg0(hInst,hwnd);
		SetTabDlg1(hInst,hwnd);
		SetTabDlg2(hInst,hwnd);
		hBtOpen=GetDlgItem(hwnd,IDC_OPEN);
		hBtClose=GetDlgItem(hwnd,IDC_CLOSE);
		hBtStart=GetDlgItem(hwnd,IDC_START);
		hBtStop=GetDlgItem(hwnd,IDC_STOP);
		EnableWindow(hBtClose,FALSE);
		EnableWindow(hBtStart,FALSE);
		EnableWindow(hBtStop,FALSE);
		break;
	case WM_COMMAND:
		switch(wParam)
		{
		case IDM_ABOUT:					//o[W_CAO\
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUTBOX),hwnd,(DLGPROC)About);
			break;
		case IDM_EXIT:					//AvP[V̏I
		case IDCANCEL:
			if(mxThread != NULL)
			{
				mxThread->Close();
				WaitForSingleObject(mxThread->m_hThread,INFINITE);
				delete mxThread;
			}
			TabDlgClose();
			EndDialog(hwnd,FALSE);
			return TRUE;
		case IDC_OPEN:					//MX̃I[v
			mxThread=new cThread(hwnd);
			char buf[10];
			GetWindowText(GetDlgItem(hwnd,IDC_STNO),buf,10);
			mxThread->StationNo=atoi(buf);
			SetForceOut();
			mxThread->Run();
			return TRUE;
		case IDC_CLOSE:					//MX̃N[Y
			if(mxThread != NULL)
			{
				mxThread->Close();
				WaitForSingleObject(mxThread->m_hThread,INFINITE);
				delete mxThread;
			}
			mxThread=NULL;
			EnableWindow(hBtOpen,TRUE);
			EnableWindow(hBtClose,FALSE);
			EnableWindow(hBtStart,FALSE);
			EnableWindow(hBtStop,FALSE);
			return TRUE;
		case IDC_START:					//DIALOG1Jn
			SetMonitorData();//Ńf[^Zbgif[^ύXꂽꍇj
			if(mxThread != NULL)
				SetEvent(mxThread->m_hMonitor);
			EnableWindow(hBtStart,FALSE);
			EnableWindow(hBtStop,TRUE);
			break;
		case IDC_STOP:					//DIALOG1~
			if(mxThread != NULL)
				ResetEvent(mxThread->m_hMonitor);
			EnableWindow(hBtStart,TRUE);
			EnableWindow(hBtStop,FALSE);
			break;
		case ID_32771:
			hinst=ShellExecute(hwnd,"open","Simulator舵.pdf",NULL,NULL,SW_SHOWNORMAL);
			break;
		}
		return FALSE;
	case WM_NOTIFY:
		switch(((NMHDR *)lParam)->code)
		{
		case TCN_SELCHANGE:				//^uy[W̑I{^
			nNo=TabCtrl_GetCurSel(hTab);//\_CAO؂ւ
			switch(nNo)
			{
			case 0:
				ShowWindow(hTabDlg0,SW_SHOW);
				ShowWindow(hTabDlg1,SW_HIDE);
				ShowWindow(hTabDlg2,SW_HIDE);
				return TRUE;
			case 1:
				ShowWindow(hTabDlg0,SW_HIDE);
				ShowWindow(hTabDlg1,SW_SHOW);
				ShowWindow(hTabDlg2,SW_HIDE);
				return TRUE;
			case 2:						
				ShowWindow(hTabDlg0,SW_HIDE);
				ShowWindow(hTabDlg1,SW_HIDE);
				ShowWindow(hTabDlg2,SW_SHOW);
				return TRUE;
			}
			return FALSE;
		}
	case WM_THREADMSG: //MXXbh̃bZ[W
		switch(lParam)
		{
		case 1:
			if(wParam==0)
				MessageBox(hwnd,_T("JȂ"),_T("ERR"),MB_OK);
			if(wParam==1)
			{
				EnableWindow(hBtOpen,FALSE);
				EnableWindow(hBtClose,TRUE);
				EnableWindow(hBtStart,TRUE);
				EnableWindow(hBtStop,FALSE);
			}
			break;
		case 2:
			//oON
			ppTabDlg1->editFlg[wParam]=1;
			InvalidateRect(hTabDlg1,NULL,FALSE);
			break;
		case 3:
			//oOFF
			ppTabDlg1->editFlg[wParam]=0;
			InvalidateRect(hTabDlg1,NULL,FALSE);
			break;
		}
		break;
	case WM_WRITEMSG:			//^u_CAOP̃bZ[W
		if(mxThread != NULL)	//o
		{
			mxThread->writeVal=wParam;
			mxThread->writeDevice=(LPSTR)lParam;
			SetEvent(mxThread->m_hWrite);
		}
		break;
	case WM_MONMSG:				//_CAOÕbZ[W
		if(mxThread != NULL)	
		{
			SetMonitorData();
		}
		break;
	case WM_EDITCHMSG:
		if(mxThread != NULL)
		{
			SetForceOut();		//o̓foCXZbgiONAOFF\p)
		}
		break;
	}
	return FALSE;
}

//^uy[W̐ݒ
VOID SetTabPage(HWND hwnd)
{
	static HWND hTab;
	TCITEM ti;
	
	hTab=GetDlgItem(hwnd,IDC_TAB1);
	memset(&ti,0,sizeof(TCITEM));
	ti.mask=TCIF_TEXT;
	ti.pszText="Devݒ";
	TabCtrl_InsertItem(hTab,0,&ti);
	ti.pszText="o";
	TabCtrl_InsertItem(hTab,1,&ti);
	ti.pszText="COMeXg";			//COMeXgp_CAO
	TabCtrl_InsertItem(hTab,2,&ti); 
}


//^u_CAOO̍쐬
BOOL SetTabDlg0(HINSTANCE hInstance,HWND hWnd)
{
	ppTabDlg0=new TabDlg0();
	hTabDlg0=ppTabDlg0->Create(hInstance,hWnd);
	return TRUE;
}

//^u_CAOP̍쐬
BOOL SetTabDlg1(HINSTANCE hInstance,HWND hWnd)
{
	ppTabDlg1=new TabDlg1();
	hTabDlg1=ppTabDlg1->Create(hInstance,hWnd);
	return TRUE;
}

//^u_CAOQ̍쐬
BOOL SetTabDlg2(HINSTANCE hInstance,HWND hWnd)
{
	ppTabDlg2=new TabDlg2();
	hTabDlg2=ppTabDlg2->Create(hInstance,hWnd);
	return TRUE;
}

//AvP[VĨ^u_CAO폜
VOID TabDlgClose()
{
	if(ppTabDlg0 != NULL)
		delete ppTabDlg0;
	if(ppTabDlg1 != NULL)
		delete ppTabDlg1;
	if(ppTabDlg2 != NULL)
		delete ppTabDlg2;
}

//j^[f[^̓o^(Xbhœ쒆͂܂j
VOID SetMonitorData()
{
	int iCount=ppTabDlg0->strMonitorData.size();
	MonitorDevData bufdata;
	if(mxThread != NULL)
	{
		mxThread->strMoniData.erase(mxThread->strMoniData.begin(),
					mxThread->strMoniData.end());

		for(int i=0 ; i<iCount ; i++)
		{
			strncpy_s(bufdata.readDev,12,ppTabDlg0->strMonitorData[i].readDev,12);
			strncpy_s(bufdata.writeDev,12,ppTabDlg0->strMonitorData[i].writeDev,12);
			bufdata.onData=ppTabDlg0->strMonitorData[i].onData;
			bufdata.offData=ppTabDlg0->strMonitorData[i].offData;
			mxThread->strMoniData.push_back(bufdata);
		}
	}
}

//o͂̃foCXݒ
VOID SetForceOut()
{
	char buf[16];
	for(int i=0 ; i<16 ; i++)
	{
		GetWindowText(ppTabDlg1->ForceText[i][1],buf,16);
		strcpy_s(mxThread->forceDev[i],16,buf);
	}
}

