#include "StdAfx.h"
#include "MXComp.h"
#include "ComThread.h"
#include <atlstr.h>


ComThread::ComThread(HWND hwnd)
{
	m_hParent=hwnd;
	m_hThreadKill=CreateEvent(NULL,TRUE,FALSE,_T("ComThreadKill"));
	m_hSend=CreateEvent(NULL,TRUE,FALSE,_T("Send"));
}


ComThread::~ComThread(void)
{
	ResetEvent(m_hThreadKill);
	CloseHandle(m_hSend);
	CloseHandle(m_hThread);
	CloseHandle(m_hThreadKill);
}

VOID ComThread::Run() //Xbh̋N
{
	m_hThread=(HANDLE)_beginthreadex(NULL,0,ComThreadRun,this,0,NULL);
}

BOOL ComThread::Close()//XbhN[Y
{
	SetEvent(m_hThreadKill);
	WaitForSingleObject(m_hThread,INFINITE);

	return TRUE;
}

unsigned ComThread::ComThreadRun(void* param)
{
	long val;
	long readVal[256];
	int devcount;

	ComThread* pParam=(ComThread*)param;

	MXComp m_MXComp;
	if(m_MXComp.Create()==FALSE)
		return 0;

	if(m_MXComp.Open(pParam->StationNo)==FALSE)
	{
		PostMessage(pParam->m_hParent,WM_CTHREADMSG,0,1);
		return 0;
	}
	else
		PostMessage(pParam->m_hParent,WM_CTHREADMSG,0,2);

	m_MXComp.SetDevice((LPSTR)pParam->outCtrl[2].c_str(),0); //M̏ݒiOj

	while(WaitForSingleObject(pParam->m_hThreadKill,20)==WAIT_TIMEOUT)
	{
		m_MXComp.GetDevice((LPSTR)pParam->outCtrl[2].c_str(),&val);	//MOoȂΓǍ
		if(val != 0)
		{
			if(pParam->readflg==0)
				val=(val+1)/2;
			m_MXComp.GetDeviceBlock((LPSTR)pParam->outData[0].c_str(),val,readVal);
			m_MXComp.SetDevice((LPSTR)pParam->outDevice[0].c_str(),1);
			m_MXComp.SetDevice((LPSTR)pParam->outCtrl[2].c_str(),0);
			//ŎMf[^i[iXgO`ǂHHHj
			//_CAOɃbZ[Wo
			CString stwork;
			pParam->readData="";
			for(int i=0 ; i<val ; i++)
			{
				stwork.Format(_T("%X:"),readVal[i]);
				pParam->readData+=stwork;
			}
			PostMessage(pParam->m_hParent,WM_CTHREADMSG,0,3);
		}

		if(WaitForSingleObject(pParam->m_hSend,0)==WAIT_OBJECT_0)
		{
			m_MXComp.SetDeviceBlock((LPSTR)pParam->inData[0].c_str(),pParam->writeCount,
												pParam->writeVal);
			m_MXComp.SetDevice((LPSTR)pParam->inDevice[0].c_str(),1);//M

			if(pParam->readflg==0)
				devcount=(pParam->writeCount+1)/2;
			else
				devcount=pParam->writeCount;

			m_MXComp.SetDevice((LPSTR)pParam->inDevice[2].c_str(),devcount);//Mf[^
			m_MXComp.SetDevice((LPSTR)pParam->inSignal.c_str(),1);	    	//Mv
			
			Sleep(1000);
			m_MXComp.SetDevice((LPSTR)pParam->inSignal.c_str(),0);
			m_MXComp.SetDevice((LPSTR)pParam->inDevice[0].c_str(),0);
			ResetEvent(pParam->m_hSend);
		}
	
	}
	return 0;
}