#include "StdAfx.h"
#include "TabDlg1.h"
#include "resource.h"
#include "atlstr.h"

TabDlg1* pTabDlg1;

TabDlg1::TabDlg1(void)
{
	pTabDlg1=this;
}


TabDlg1::~TabDlg1(void)
{
	CsvDataWrite();
	DeleteObject(bkONBrush);
	DeleteObject(bkOFFBrush);
	DestroyWindow(hTabDlg1);
	RemoveProp(hTabDlg1,"TabDlg1");
}

HWND TabDlg1::Create(HINSTANCE hInstance,HWND hWnd)
{
	hInst=hInstance;
	hParent=hWnd;
	hTabDlg1=CreateDialog(hInst,MAKEINTRESOURCE(IDD_TABDLG1),hParent,(DLGPROC)TabDlg1Proc);
	if(hTabDlg1==NULL)
		return FALSE;

	SetProp(hTabDlg1,"TabDlg1",this);

	SetList();
	CsvDataRead();

	for(int i=0 ; i<16 ; i++)
	{
		editFlg[i]=0;
	}

	UpdateWindow(hTabDlg1);

	return hTabDlg1;
}

VOID TabDlg1::SetList()
{
	ForceText[0][0]=GetDlgItem(hTabDlg1,IDC_EDIT1);
	ForceText[0][1]=GetDlgItem(hTabDlg1,IDC_EDIT2);
	ForceText[0][2]=GetDlgItem(hTabDlg1,IDC_EDIT3);
	ForceText[1][0]=GetDlgItem(hTabDlg1,IDC_EDIT5);
	ForceText[1][1]=GetDlgItem(hTabDlg1,IDC_EDIT6);
	ForceText[1][2]=GetDlgItem(hTabDlg1,IDC_EDIT7);
	ForceText[2][0]=GetDlgItem(hTabDlg1,IDC_EDIT8);
	ForceText[2][1]=GetDlgItem(hTabDlg1,IDC_EDIT9);
	ForceText[2][2]=GetDlgItem(hTabDlg1,IDC_EDIT10);
	ForceText[3][0]=GetDlgItem(hTabDlg1,IDC_EDIT11);
	ForceText[3][1]=GetDlgItem(hTabDlg1,IDC_EDIT12);
	ForceText[3][2]=GetDlgItem(hTabDlg1,IDC_EDIT13);
	ForceText[4][0]=GetDlgItem(hTabDlg1,IDC_EDIT14);
	ForceText[4][1]=GetDlgItem(hTabDlg1,IDC_EDIT15);
	ForceText[4][2]=GetDlgItem(hTabDlg1,IDC_EDIT16);
	ForceText[5][0]=GetDlgItem(hTabDlg1,IDC_EDIT17);
	ForceText[5][1]=GetDlgItem(hTabDlg1,IDC_EDIT18);
	ForceText[5][2]=GetDlgItem(hTabDlg1,IDC_EDIT19);
	ForceText[6][0]=GetDlgItem(hTabDlg1,IDC_EDIT20);
	ForceText[6][1]=GetDlgItem(hTabDlg1,IDC_EDIT21);
	ForceText[6][2]=GetDlgItem(hTabDlg1,IDC_EDIT22);
	ForceText[7][0]=GetDlgItem(hTabDlg1,IDC_EDIT23);
	ForceText[7][1]=GetDlgItem(hTabDlg1,IDC_EDIT24);
	ForceText[7][2]=GetDlgItem(hTabDlg1,IDC_EDIT25);
	ForceText[8][0]=GetDlgItem(hTabDlg1,IDC_EDIT26);
	ForceText[8][1]=GetDlgItem(hTabDlg1,IDC_EDIT27);
	ForceText[8][2]=GetDlgItem(hTabDlg1,IDC_EDIT28);
	ForceText[9][0]=GetDlgItem(hTabDlg1,IDC_EDIT29);
	ForceText[9][1]=GetDlgItem(hTabDlg1,IDC_EDIT30);
	ForceText[9][2]=GetDlgItem(hTabDlg1,IDC_EDIT31);
	ForceText[10][0]=GetDlgItem(hTabDlg1,IDC_EDIT32);
	ForceText[10][1]=GetDlgItem(hTabDlg1,IDC_EDIT33);
	ForceText[10][2]=GetDlgItem(hTabDlg1,IDC_EDIT34);
	ForceText[11][0]=GetDlgItem(hTabDlg1,IDC_EDIT35);
	ForceText[11][1]=GetDlgItem(hTabDlg1,IDC_EDIT36);
	ForceText[11][2]=GetDlgItem(hTabDlg1,IDC_EDIT37);
	ForceText[12][0]=GetDlgItem(hTabDlg1,IDC_EDIT38);
	ForceText[12][1]=GetDlgItem(hTabDlg1,IDC_EDIT39);
	ForceText[12][2]=GetDlgItem(hTabDlg1,IDC_EDIT40);
	ForceText[13][0]=GetDlgItem(hTabDlg1,IDC_EDIT41);
	ForceText[13][1]=GetDlgItem(hTabDlg1,IDC_EDIT42);
	ForceText[13][2]=GetDlgItem(hTabDlg1,IDC_EDIT43);
	ForceText[14][0]=GetDlgItem(hTabDlg1,IDC_EDIT44);
	ForceText[14][1]=GetDlgItem(hTabDlg1,IDC_EDIT45);
	ForceText[14][2]=GetDlgItem(hTabDlg1,IDC_EDIT46);
	ForceText[15][0]=GetDlgItem(hTabDlg1,IDC_EDIT47);
	ForceText[15][1]=GetDlgItem(hTabDlg1,IDC_EDIT48);
	ForceText[15][2]=GetDlgItem(hTabDlg1,IDC_EDIT49);

	bkONBrush=CreateSolidBrush(RGB(200,255,255));
	bkOFFBrush=CreateSolidBrush(RGB(200,200,200));
}

VOID TabDlg1::CsvDataRead()
{
	std::ifstream ifs("Force.csv");
	if(!ifs)
		return;

	int i=0;
	int k=0;
	std::string csvdata="";
	while(std::getline(ifs,csvdata))
	{
		std::string devdata="";
		std::istringstream stream(csvdata);
		while(getline(stream,devdata,','))
		{
			SetWindowText(ForceText[i][k],devdata.c_str());
			k++;
		}
		k=0;
		i++;
	}
}

VOID TabDlg1::CsvDataWrite()
{
	std::ofstream ofs("Force.csv");
	char buf[16];
	for(int i=0 ; i<15 ; i++)
	{
		GetWindowText(ForceText[i][0],buf,16);
		ofs<<buf<<",";
		GetWindowText(ForceText[i][1],buf,16);
		ofs<<buf<<",";
		GetWindowText(ForceText[i][2],buf,16);
		ofs<<buf<<std::endl;
	}
}

HBRUSH TabDlg1::SetEditColor(HWND hwnd,HDC hdc)
{
	SetBkMode(hdc,TRANSPARENT);
	if(hwnd==ForceText[0][0])
	{
		if(editFlg[0]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[1][0])
	{
		if(editFlg[1]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[2][0])
	{
		if(editFlg[2]==0)
			return bkOFFBrush;
		else 
			return bkONBrush;
	}
	if(hwnd==ForceText[3][0])
	{
		if(editFlg[3]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[4][0])
	{
		if(editFlg[4]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[5][0])
	{
		if(editFlg[5]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[6][0])
	{
		if(editFlg[6]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[7][0])
	{
		if(editFlg[7]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[8][0])
	{
		if(editFlg[8]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[9][0])
	{
		if(editFlg[9]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[10][0])
	{
		if(editFlg[10]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[11][0])
	{
		if(editFlg[11]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[12][0])
	{
		if(editFlg[12]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[13][0])
	{
		if(editFlg[13]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[14][0])
	{
		if(editFlg[14]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}
	if(hwnd==ForceText[15][0])
	{
		if(editFlg[15]==0)
			return bkOFFBrush;
		else
			return bkONBrush;
	}

	return NULL;
}

VOID TabDlg1::WriteDevice(int btnNo)
{
	char buf1[16];
	char buf2[16];
	GetWindowText(ForceText[btnNo][1],buf1,16);
	GetWindowText(ForceText[btnNo][2],buf2,16);
	if(strcmp(buf1,"") != 0)
	{
		SendMessage(hParent,WM_WRITEMSG,(WPARAM)atol(buf2),(LPARAM)buf1);
	}
}

VOID TabDlg1::ResetDevice(int btnNo)
{
	char buf[16];
	GetWindowText(ForceText[btnNo][1],buf,16);
	if(strcmp(buf,"") != 0)
		SendMessage(hParent,WM_WRITEMSG,0,(LPARAM)buf);
}

BOOL TabDlg1::TabDlg1Message(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	HBRUSH editbrush;
	switch(msg)
	{
	case WM_CTLCOLOREDIT:
		editbrush=(SetEditColor((HWND)lParam,(HDC)wParam));
		if(editbrush != NULL)
			return (LRESULT)editbrush;
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON1:
			WriteDevice(0);
			break;
		case IDC_BUTTON3:
			WriteDevice(1);
			break;
		case IDC_BUTTON5:
			WriteDevice(2);
			break;
		case IDC_BUTTON7:
			WriteDevice(3);
			break;
		case IDC_BUTTON9:
			WriteDevice(4);
			break;
		case IDC_BUTTON11:
			WriteDevice(5);
			break;
		case IDC_BUTTON13:
			WriteDevice(6);
			break;
		case IDC_BUTTON15:
			WriteDevice(7);
			break;
		case IDC_BUTTON17:
			WriteDevice(8);
			break;
		case IDC_BUTTON19:
			WriteDevice(9);
			break;
		case IDC_BUTTON21:
			WriteDevice(10);
			break;
		case IDC_BUTTON23:
			WriteDevice(11);
			break;
		case IDC_BUTTON25:
			WriteDevice(12);
			break;
		case IDC_BUTTON27:
			WriteDevice(13);
			break;
		case IDC_BUTTON29:
			WriteDevice(14);
			break;
		case IDC_BUTTON31:
			WriteDevice(15);
			break;
		case IDC_BUTTON2:
			ResetDevice(0);
			break;
		case IDC_BUTTON4:
			ResetDevice(1);
			break;
		case IDC_BUTTON6:
			ResetDevice(2);
			break;
		case IDC_BUTTON8:
			ResetDevice(3);
			break;
		case IDC_BUTTON10:
			ResetDevice(4);
			break;
		case IDC_BUTTON12:
			ResetDevice(5);
			break;
		case IDC_BUTTON14:
			ResetDevice(6);
			break;
		case IDC_BUTTON16:
			ResetDevice(7);
			break;
		case IDC_BUTTON18:
			ResetDevice(8);
			break;
		case IDC_BUTTON20:
			ResetDevice(9);
			break;
		case IDC_BUTTON22:
			ResetDevice(10);
			break;
		case IDC_BUTTON24:
			ResetDevice(11);
			break;
		case IDC_BUTTON26:
			ResetDevice(12);
			break;
		case IDC_BUTTON28:
			ResetDevice(13);
			break;
		case IDC_BUTTON30:
			ResetDevice(14);
			break;
		case IDC_BUTTON32:
			ResetDevice(15);
			break;
		case IDC_EDIT2:
		case IDC_EDIT6:
		case IDC_EDIT9:
		case IDC_EDIT12:
		case IDC_EDIT15:
		case IDC_EDIT18:
		case IDC_EDIT21:
		case IDC_EDIT24:
		case IDC_EDIT27:
		case IDC_EDIT30:
		case IDC_EDIT33:
		case IDC_EDIT36:
		case IDC_EDIT39:
		case IDC_EDIT42:
		case IDC_EDIT45:
		case IDC_EDIT48:
			{
			switch(HIWORD(wParam))
				{
				case EN_KILLFOCUS:	
					SendMessage(hParent,WM_EDITCHMSG,0,0);
				break;
				}
			}
			break;
		}	
	}
	return FALSE;
}


//**************************************************************
//bZ[vV[W
//**************************************************************
BOOL CALLBACK TabDlg1Proc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	TabDlg1* pdlg=(TabDlg1*)GetProp(hwnd,"TabDlg1");

	if(pdlg==NULL)
		return FALSE;

	return pdlg->TabDlg1Message(hwnd,msg,wParam,lParam);
}
