#include "StdAfx.h"
#include "resource.h"
#include "ComThread.h"
#include "TabDlg2.h"

TabDlg2* pTabDlg2;

TabDlg2::TabDlg2(void)
{
	pTabDlg2=this;
	pComThread=NULL;
}


TabDlg2::~TabDlg2(void)
{
	CsvDataWrite();
	DestroyWindow(hTabDlg2);
	RemoveProp(hTabDlg2,"TabDlg2");
}

//_CAO쐬
HWND TabDlg2::Create(HINSTANCE hInstance,HWND hWnd)
{
	hInst=hInstance;
	hParent=hWnd;
	hTabDlg2=CreateDialog(hInst,MAKEINTRESOURCE(IDD_TABDLG2),hParent,(DLGPROC)Tabdlg2Proc);
	if(hTabDlg2==NULL)
		return FALSE;

	SetProp(hTabDlg2,"TabDlg2",this);
	SetList();
	if(CsvDataRead()==TRUE)
		SetDevice();

	UpdateWindow(hTabDlg2);

	return hTabDlg2;
}

//_CAÕGfBbgRg[̃nhێ
BOOL TabDlg2::SetList()
{
	ComData[0]=GetDlgItem(hTabDlg2,IDC_EDIT1);
	ComData[1]=GetDlgItem(hTabDlg2,IDC_EDIT2);
	ComData[2]=GetDlgItem(hTabDlg2,IDC_EDIT3);
	ComData[3]=GetDlgItem(hTabDlg2,IDC_EDIT4);
	ComData[4]=GetDlgItem(hTabDlg2,IDC_EDIT50);
	ComData[5]=GetDlgItem(hTabDlg2,IDC_EDIT51);
	ComData[6]=GetDlgItem(hTabDlg2,IDC_EDIT52);
	ComData[7]=GetDlgItem(hTabDlg2,IDC_EDIT5);
	ComData[8]=GetDlgItem(hTabDlg2,IDC_EDIT53);
	ComData[9]=GetDlgItem(hTabDlg2,IDC_EDIT54);
	ComData[10]=GetDlgItem(hTabDlg2,IDC_EDIT55);
	ComData[11]=GetDlgItem(hTabDlg2,IDC_EDIT8);

	radio=1;
	SendMessage(GetDlgItem(hTabDlg2,IDC_RADIO1),BM_SETCHECK,(WPARAM)radio,0L);
		
	return TRUE;
}

//CSVt@Cf[^ǂݏoA\
BOOL TabDlg2::CsvDataRead()
{
	std::ifstream ifs("ComData.csv");
	if(!ifs)
		return FALSE;

	int i=0;
	std::string csvdata="";
	while(std::getline(ifs,csvdata))
	{
		if(strcmp(csvdata.c_str(),"") != 0)
			SetWindowText(ComData[i],csvdata.c_str());
		i++;
	}
	return TRUE;
}

//CSVt@Cփf[^ۑ
VOID TabDlg2::CsvDataWrite()
{
	std::ofstream ofs("ComData.csv");
	char buf[256];
	for(int i=0 ; i<10 ;i++)
	{
		GetWindowText(ComData[i],buf,256);
		if(strcmp(buf,"")!=0)
			ofs<<buf<<std::endl;
	}
}


//GfBbgRg[̃foCXCOMʐMp̃foCXWJ
VOID TabDlg2::SetDevice()
{
	char buf[12];
	std::string device;
	std::string workstring;
	GetWindowText(ComData[0],buf,12);
	outCtrl[0]=buf;
	device=outCtrl[0].substr(0,1);
	if(device=="")
		return;
	workstring=outCtrl[0].substr(1);
	outCtrl[1]=device+std::to_string((long double)std::stod(workstring)+1);
	outCtrl[2]=device+std::to_string((long double)std::stod(workstring)+2);
	
	GetWindowText(ComData[1],buf,12);
	outData[0]=buf;
	device=outData[0].substr(0,1);
	if(device=="")
		return;
	workstring=outData[0].substr(1);
	for(int i=1 ; i<256 ; i++)
	{
		outData[i]=device+std::to_string((long double)std::stod(workstring)+i);
	}

	GetWindowText(ComData[2],buf,12);
	outDevice[0]=buf;
	device=outDevice[0].substr(0,1);
	if(device=="")
		return;
	workstring=outDevice[0].substr(1);
	outDevice[1]=device+std::to_string((long double)std::stod(workstring)+1);

	GetWindowText(ComData[3],buf,12);
	inSignal=buf;

	GetWindowText(ComData[4],buf,12);
	inCtrl[0]=buf;
	device=inCtrl[0].substr(0,1);
	if(device=="")
		return;
	workstring=inCtrl[0].substr(1);
	inCtrl[1]=device+std::to_string((long double)std::stod(workstring)+1);
	inCtrl[2]=device+std::to_string((long double)std::stod(workstring)+2);

	GetWindowText(ComData[5],buf,12);
	inData[0]=buf;
	device=inData[0].substr(0,1);
	if(device=="")
		return;
	workstring=inData[0].substr(1);
	for(int i=1 ; i<256 ; i++)
	{
		inData[i]=device+std::to_string((long double)std::stod(workstring)+i);
	}

	GetWindowText(ComData[6],buf,12);
	inDevice[0]=buf;
	device=inDevice[0].substr(0,1);
	if(device=="")
		return;
	workstring=inDevice[0].substr(1);
	inDevice[1]=device+std::to_string((long double)std::stod(workstring)+1);
}

//XbhŎgpfoCXɃRs[
VOID TabDlg2::SetDeviceNo()
{
	for(int i=0 ; i<3 ; i++)
	{
		pComThread->outCtrl[i]=outCtrl[i];
		pComThread->inCtrl[i]=inCtrl[i];
	}
	for(int i=0 ; i<256 ; i++)
	{
		pComThread->outData[i]=outData[i];
		pComThread->inData[i]=inData[i];
	}
	for(int i=0 ; i<2 ; i++)
	{
		pComThread->outDevice[i]=outDevice[i];
		pComThread->inDevice[i]=inDevice[i];
	}
	pComThread->inSignal=inSignal;

}

//f[^M
VOID TabDlg2::SendData(int messageNo)
{
	if(pComThread==NULL)
		return;

	char buf[256];
	std::string sendData;
	GetWindowText(ComData[messageNo+6],buf,256);
	sendData=buf;
	//Ǎf[^LONG̔zɕϊ
	int count=sendData.length();
	count=(count+3)/4;
	std::string sendbuf;
	pComThread->writeCount=count;
	for(int i=0 ; i<count ; i++)
	{
		sendbuf=sendData.substr(i*4,4);
		//LONGɕύX
		pComThread->writeVal[i]=strtol(sendbuf.c_str(),NULL,16);
	}
	SetEvent(pComThread->m_hSend);
}

BOOL TabDlg2::TabDlg2Message(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	char buf[12];
	switch(msg)
	{
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON5:	//Jn{^
			if(pComThread == NULL)
			{
				pComThread=new ComThread(hwnd);
				GetDlgItemText(hParent,IDC_STNO,buf,12);
				pComThread->StationNo=atoi(buf);
				//ŃfoCXZbgi͖Hj
				//rŕύXꂽꍇ͂ǂ邩HHH
				SetDeviceNo();
				pComThread->readflg=((int)(DWORD)SendMessage(GetDlgItem(hTabDlg2,IDC_RADIO1),BM_GETCHECK,0L,0L));
				pComThread->Run();
			}
			break;
		case IDC_BUTTON6:	//~{^
			if(pComThread != NULL)
			{
				pComThread->Close();
				WaitForSingleObject(pComThread->m_hThread,INFINITE);
				delete pComThread;
			}
			pComThread=NULL;
			EnableWindow(GetDlgItem(hwnd,IDC_BUTTON5),TRUE);
			break;
		case IDC_BUTTON33:
			SendData(1);
			break;
		case IDC_BUTTON34:
			SendData(2);
			break;
		case IDC_BUTTON35:
			SendData(3);
			break;
		case IDC_BUTTON36:
			SendData(4);
			break;
		case IDC_EDIT1:
		case IDC_EDIT2:
		case IDC_EDIT3:
		case IDC_EDIT4:
		case IDC_EDIT50:
		case IDC_EDIT51:
		case IDC_EDIT52:
			{
				switch(HIWORD(wParam))
				{
				case EN_KILLFOCUS:
					SetDevice();
					break;
				}
				break;
			}
		}
		break;
	case WM_CTHREADMSG:
		switch(lParam)
		{
		case 1:
			MessageBox(hwnd,_T("JȂ"),_T("ERR"),MB_OK);
			break;
		case 2:
			EnableWindow(GetDlgItem(hwnd,IDC_BUTTON5),FALSE);
			break;
		case 3:
			SetWindowText(ComData[11],pComThread->readData.c_str());
			break;
		}
	}
	return FALSE;
}




//**************************************************************
//bZ[vV[W
//**************************************************************
BOOL CALLBACK Tabdlg2Proc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	TabDlg2* pdlg=(TabDlg2*)GetProp(hwnd,"TabDlg2");

	if(pdlg==NULL)
		return FALSE;

	return pdlg->TabDlg2Message(hwnd,msg,wParam,lParam);
}

